import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

class AnimationCanvas extends Canvas {

  final int EAST = 1;
  final int WEST = 2;
  final int SOUTH = 3;
  final int NORTH = 4;

  protected int x;
  protected int y;
  protected boolean animate;
  protected Color colorBackground;
  protected int type;
  protected Image arrow;
  protected Laplace appletMain = null;

  public AnimationCanvas(Color _colorBackground, int _type, Laplace _appletMain) {

    colorBackground = _colorBackground;
    type = _type;

    appletMain = _appletMain;

    setBounds(0, 0, 20, 20);
    setupGUI();
  }

  public AnimationCanvas(Color _colorBackground, int _type, Laplace _appletMain, boolean _northNeighbor) {

    colorBackground = _colorBackground;
    type = _type;

    appletMain = _appletMain;

    setBounds(0, 0, 20, 20);
    setupGUI(_northNeighbor);
  }

  public void setupGUI() {
    if ( type == NORTH ) {
      x = 100;
      y = 0;
      arrow = appletMain.getImage(appletMain.getCodeBase(), "upperArrow.gif");
    }

    if ( type == SOUTH ) {
      x = 120;
      y = 0;
      arrow = appletMain.getImage(appletMain.getCodeBase(), "downArrow.gif");
    }
  }

  public void setupGUI(boolean northNeighbor) {
    int adjustPosition;

    if ( !northNeighbor ) {
      adjustPosition = 60;
    }
    else {
      adjustPosition = 0;
    }

    if ( type == WEST ) {
      x = 0;
      y = adjustPosition + 50;
      arrow = appletMain.getImage(appletMain.getCodeBase(), "rightArrow.gif");
    }

    if ( type == EAST ) {
      x = 0;
      y = adjustPosition + 30;
      arrow = appletMain.getImage(appletMain.getCodeBase(), "leftArrow.gif");
    }
  }

  public void paint(Graphics g) {
    //appletMain.printLine("drawing " + type);
    if ( animate ) {
      //g.drawImage(arrow, x, y, 20, 20, this);
      g.setColor(Color.blue);

      if ( type == NORTH ) {
	g.drawLine(x, y, x, y+20);
	g.drawLine(x, y, x-5, y+10);
	g.drawLine(x, y, x+5, y+10);
      }
      if ( type == SOUTH ) {
	g.drawLine(x, y, x, y+20);
	g.drawLine(x, y+20, x-5, y+10);
	g.drawLine(x, y+20, x+5, y+10);
      }
      if ( type == WEST ) {
	g.drawLine(x, y, x+20, y);
	g.drawLine(x, y, x+10, y-5);
	g.drawLine(x, y, x+10, y+5);
      }
      if ( type == EAST ) {
	g.drawLine(x, y, x+20, y);
	g.drawLine(x+20, y, x+10, y-5);
	g.drawLine(x+20, y, x+10, y+5);
      }
    }
    else {
      g.setColor(colorBackground);
      //g.setColor(Color.black);
      g.fillRect(x, y, 10, 20);
    }
  }

  public void redraw(boolean _animate) {
    animate = _animate;
    repaint();
  }
}
